#ifndef GLOBALTHEMEHELPER_P_H
#define GLOBALTHEMEHELPER_P_H

#include <QObject>
#include <QMap>

class GlobalTheme;
class QGSettings;

class GlobalThemeHelperPrivate
{
public:
    GlobalThemeHelperPrivate() {}
    void initThemes();

    // info
    QString getCurrentThemeName();
    bool setCurrentTheme(const QString &theme);

    bool getCurrentThemeModified();

    // color schemes
    bool getThemeSupportLightDarkMode(const QString &theme);

    // qt
    QString getThemeWidgetStyleName(const QString &theme);

    // gtk
    QString getThemeGtkStyleName(const QString &theme);

    // xdg
    QString getThemeIconThemeName(const QString &theme);
    QString getThemeCursorThemeName(const QString &theme);

    // wallpaper
    QString getThemeWallPaper(const QString &theme);

    // effect
    bool getThemeSupportBlur(const QString &theme);
    bool getThemeSupportTransparency(const QString &theme);

    // animation
    bool getThemeSupportAnimation(const QString &theme);

    QMap<QString, GlobalTheme *> globalThemes;
    QGSettings *settings = nullptr;
};

class Thumbnailer : public QObject
{
    Q_OBJECT
public:
    explicit Thumbnailer(GlobalTheme *theme);

Q_SIGNALS:
    void finished(const QPixmap &pixmap);

public Q_SLOTS:
    void doThumbnail();

private:
    QString picturePath;
};

#endif // GLOBALTHEMEHELPER_P_H
